using Model;
using Model.Serialization;
using Model.Stub;
using Newtonsoft.Json.Linq;
using NuGet.Frameworks;
using System;

namespace TestUnitaires
{

    public class TU_LINQ_XML_Serialization
    {
        [Theory]
        [InlineData("Rference")]
        public void TU_Methods(string? test)
        {

            Playlist p = new Playlist(test, "PlaceHolder", "place.holder");
            Album album = new Album(test, "place.holder", new Artist("test"), "PlaceHolder", "PlaceHolder");
            CustomTitle t = new CustomTitle(test, "test. mp3", "Banger", "path");
            Artist artist = new Artist(test);
            LinqXmlSerialization l = new LinqXmlSerialization(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "Data"));
            InfoTitle info = new InfoTitle(test, "url.test", "infos", "desc", Genre.POP, 345);
            /*Assert.NotEmpty(l.Albums);
            Assert.NotEmpty(l.Artists);
            Assert.NotEmpty(l.InfoTitles);
            Assert.NotEmpty(l.Playlists);
            Assert.NotEmpty(l.CustomTitles);*/
            l.AddCustomTitle(t);
            l.AddPlaylist(p);
            l.AddAlbum(album);
            l.AddArtist(artist);
            l.AddInfoTitle(info);
            Assert.Contains(t, l.CustomTitles);
            Assert.Contains(album, l.Albums);
            Assert.Contains(p, l.Playlists);
            Assert.Contains(info, l.InfoTitles);
            Assert.Contains(artist, l.Artists);
            l.RemovePlaylist(p);
            l.RemoveAlbum(album);
            l.RemoveCustomTitle(t);
            l.RemoveInfoTitle(info);
            Assert.DoesNotContain(t, l.CustomTitles);
            Assert.DoesNotContain(p, l.Playlists);
            Assert.DoesNotContain(album, l.Albums);
            Assert.DoesNotContain(info,l.InfoTitles);
            l.AddCustomTitle(t);
            l.AddPlaylist(p);
            l.AddAlbum(album);
            l.AddArtist(artist);
            l.AddInfoTitle(info);
            Assert.Equal(l.GetAlbums(), l.Albums);
            Assert.Equal(l.GetInfoTitles(), l.InfoTitles);
            Assert.Equal(l.GetCustomTitles(), l.CustomTitles);
            Assert.Equal(l.GetPlaylists(), l.Playlists);
            Assert.Equal(l.GetArtists(), l.Artists);
            Assert.Equal(l.GetAlbumByName(test), album);
            Assert.Equal(l.GetPlaylistByName(test), p);
            Assert.Equal(l.GetInfoTitleByName(test), info);
            Assert.Equal(l.GetArtistByName(test), artist);
        }
    }
    
}